/*    MORE OR LESS NCURSES ver. 10/17/05   Compare and Order numbers.
                    Copyright (C) 2005 by John Slayton

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA, 02110-1301, USA.

Author's address as of 10/5/05 is 260 Sundance Ct, Azusa, CA 91792. 
E-mail to www.juanslayton@dialup4less.com  */

#ifdef HAVE_LIBCURSES
#include <curses.h>
#else
#include <ncurses/curses.h>
#endif

#include <stdio.h>
#include <stdlib.h>

                             /*  VARIABLES  */

int a = 0;
int b = 0;
int c = 0; 
int d = 0;
int e = 0;
int f = 0;
int o = 0; /*  Game flag.  On 0 branch to comparison, on 1 to ordering  */
int n = 0;
int n1 = 0;
int n2 = 0;
int n3 = 0;
int n4 = 0;
int nr = 0;
int panic = 0;
int score = 0;
int seed = 0;
int sp = 0;
int t1 = 0;
int t2 = 0;
int t3 = 0;
int t4 = 0;
int win = 0;

int color[25] = {1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1 };

char ch = '"';

                             /*  METHODS  */

int bad(); /*  Reports wrong answers and zero score to screen  */
int chance(); /*  Generates pseudorandom numbers  */
int compare_numbers(); /*  Manages comparison exercises  */
int check_order(); /*  Evaluates student answers for ordering game  */
int check_compare(); /*  Evaluates student answers for comparison game  */
int get_answer();
int good(); /*  Reports right answers and new score  */
int input_character(); /* Handles student input of numbers  */
int input_operator(); /*  Handles student input of ">", "=", and "<"  */
int order_numbers(); /*  Manages ordering exercises  */
int print_gpl();
int WIN();

                        /*  START OF PROGRAM  */

int main()
{
                 /*  Initialize random number generation  */

  seed = time(NULL); 
  srand(seed);

                        /*  Set ncurses parameters  */  

  initscr();
  cbreak();
  noecho();
  nonl();
  intrflush (stdscr,FALSE);
  keypad (stdscr,TRUE);
  curs_set(0);

                           /*  Set letter attributes  */

  start_color();
  init_pair (1, COLOR_RED, COLOR_WHITE);
  init_pair (2, COLOR_BLUE, COLOR_WHITE);
  init_pair (3, COLOR_GREEN, COLOR_WHITE);
  init_pair (4, COLOR_MAGENTA, COLOR_WHITE);
  init_pair (5, COLOR_CYAN, COLOR_BLACK);
  init_pair (6, COLOR_GREEN, COLOR_BLACK);
  init_pair (7, COLOR_BLACK, COLOR_WHITE);
  bkgd (COLOR_PAIR(1));

                            /*   Print title page  */

  attron (COLOR_PAIR(1));
  leap:
  clear();
  mvprintw (5,34," MORE OR LESS\n"
  "                                  Version 10/17/05\n\n\n\n");
  attron (COLOR_PAIR(4));
  printw("                                  by John Slayton\n"
         "                                  Copyright  2005\n\n\n\n");
  attron (COLOR_PAIR(2));
  printw ("                            Distributable under the GNU\n"
  "                              General Public License\n"
  "                        Contact the Free Software Foundation\n"
  "                       51 Franklin St, Boston, MA 02110-1301\n\n"
  "   MORE OR LESS comes with ABSOLUTELY NO WARRANTY\n"
  "   For license details, type 'D'");
  attron (COLOR_PAIR(1));
  mvprintw (23, 3, "Push Enter to start...");
  refresh();
  attron (COLOR_PAIR(2));
  a=getch();
  if ((a == 68) || (a == 100))
    {
       print_gpl();
       goto leap;
    }
  if (a != 13)
       {
         goto leap;
       }

                            /*  Print Menu  */

  while (1 == 1)
    {
      clear();
      mvprintw (5, 15, "            BIG BIGGER BIGGEST\n\n");
      attron (COLOR_PAIR(1));
      printw ("                         Two Numbers to Compare\n\n"
      "                         A - With Two Digits\n"
      "                         B - With Three Digits\n"
      "                         C - With Four Digits\n\n\n");
      attron (COLOR_PAIR(4));
      printw ("                         Four Numbers to Order\n\n"
      "                         D - With Two Digits\n"
      "                         E - With Three Digits\n"
      "                         F - With Four Digits\n\n");
      attron (COLOR_PAIR(7));
      printw ("                         G - Exit the Program");
      refresh();

                        /*  Select from menu  */
  
      a = 0;
      while ((a < 65 || a > 71) && (a < 97 ||  a > 103) ) /* report 'a-g'  */
        {
          a = getch();
          d = 0; 
          if (a > 90) /*  Change ASCII lower case to upper  */
            {
              a = a - 32;
            }
          if (a == 65) /*  Select 2 digit comparisons  */
            {
              o = 0;
              f = 100;
              sp = 1;
            }
          if (a == 66) /*  Select 3 digit comparisons  */
            {
              o = 0;
              f = 1000;
              sp = 2; 
            }
          if (a == 67) /*  Select 4 digit comparisons  */
            {
              o = 0;
              f = 10000;
              sp = 3;
            }
          if (a == 68) /*  Select 2 digit ordering problems  */
            {
              o = 1;
              d = 2;
              f = 100;
            }
          if (a == 69) /*  Select 3 digit ordering problems  */
            {
              o = 1;
              d = 3;
              f = 1000;
            }
          if (a == 70) /*  Select 4 digit ordering problems  */
            {
              o = 1;
              d = 4;
              f = 10000;
            }
          if (a == 71) /*  Select program exit  */
            {
              nocbreak();
              endwin();
              return 0;
            }
        }

             /*  Branch to comparison or ordering methods  */

      if (o == 0)
        {
          compare_numbers();
        }
      else
        {
          order_numbers();
        }
      if (panic == 1)
        {
          score = 0;
          curs_set(0);
        }
      panic = 0;
    }
}

           /*  FUNCTION DEFINITIONS (in alphabetical order)  */

int bad()  /*  Report bad answers; Reset score to 0  */
{
  curs_set(0);
  bkgd (COLOR_PAIR(6));
  score=0;
  attron (COLOR_PAIR(5));
  attron (A_BLINK);
  attron (A_BOLD);
  mvprintw (14, 13, "YOU GOOFED!\n\n\n\n");
  printw ("                            SCORE IS %d \n\n\n\n", score);
  attroff (A_BLINK); 
  attroff (A_BOLD);
  attron (COLOR_PAIR(6));
  mvprintw (22, 43, "Push ENTER for Next Problem");
  refresh();
  a=getch();
  if (a == '\033')
    {
      panic = 1;
    }
  bkgd (COLOR_PAIR(1));
  return 0;
}


int chance() /*  generate random number within selected range  */
{
  back:
  while(1==1)
    {
      b=random() / (2000000000 / f);
      if ( (b <= (f - 1)) && (b >= (f / 10)) && (b != 0) )  
        {
          return 0;
        }
    }
}

int check_compare() /*  Evaluate student answers in comparison  */
{
  if (d == 1)
    {
      if (panic == 1)
        {
          return 0;
        }
      if (n1 < n2)
        {
          good();
        }
      else 
        {
          bad();
        }
    }
  if(d == 2)
    {
      if (panic == 1)
        {
          return 0;
        } 
      if (n1 > n2)
        {
          good();
        }
      else
        {
          bad();
        }
    }
  if(d == 3)
    { 
      if (panic == 1)
        {
          return 0;
        }
      if (n1 == n2)
        {
          good();
        }
      else
        {
          bad();
        }
    }
  return 0;
} 

int check_order() /*  Evaluate student answers in ordering section  */
{

  /*  Check to see if answers are ordered by size  */

  if ( ! (n1 <= n2) && (n2 <= n3) && (n3 <= n4) ) 
    {
      bad();
      return 0;
    }

  /*  Check to see if student actually used the problem numbers  */

  if ( ( (n1 == t1) || (n1 == t2) || (n1 == t3) || (n1 == t4))
          && ((n2 == t1) || (n2 == t2) || (n2 == t3) || (n2 == t4))
          && ((n3 == t1) || (n3 == t2) || (n3 == t3) || (n3 == t4))
          && ((n4 == t1) || (n4 == t2) || (n4 == t3) || (n4 == t4) ) )
    {
      good();
    }
  else
    {
      bad();
    }
  return 0;
}

int compare_numbers()
{
  cycle:
  curs_set(1);
  clear();
  attron (COLOR_PAIR(7));
  mvprintw (5, 15, "COMPARE THESE NUMBERS USING THE SYMBOLS >, <, OR =");
  attron (COLOR_PAIR(1));
  chance();
  n1 = b;
  mvprintw (15, 30, "%d", n1);
  chance();
  n2 = b;
  mvprintw (15, 40, "%d", n2);
  refresh();
  input_operator();
  refresh(); /*  Display answer  */
  if (panic == 1)
    {
      return 0;
    } 
  check_compare();
  if (panic == 1)
    {
      return 0;
    }
  goto cycle;
  return 0;
} 

int get_answer()
{
  n1 = 0;
  n2 = 0;
  n3 = 0;
  n4 = 0;
  mvprintw (11, 23, "");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n1 = (10 * n1) + n;
      if (panic == 1)
        {
          return 0;
        }
    }
  mvprintw (11, 33, "");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n2 = (10 * n2) + n; 
      if (panic == 1)
        {
          return 0;
        }
    }
  mvprintw (11,43,"");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n3 = (10 * n3) + n;
      if (panic == 1)
        {
          return 0;
        }
    }
  mvprintw (11, 53, "");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n4 = (10 * n4) + n;
      if (panic == 1)
        {
          return 0;
        }
    }
  return 0;
} 

int good()
{
  curs_set(0);
  if (score == 4)
    {
      WIN();
      return 0;
    }
  score = score + 1;
  attron (COLOR_PAIR(7));
  mvprintw (14, 13, "GOOD WORK!\n\n\n\n");
  attron (COLOR_PAIR(1));
  printw ("                            SCORE IS %d", score);
  attron (COLOR_PAIR(7));
  mvprintw (22, 43, "Push ENTER for Next Problem");
  refresh();
  attron (COLOR_PAIR(1));
  a = getch();
  if (a == '\033')
    {
      panic = 1;
    }
  return 0;
}

int input_character()
{ 
  a = 0;
  while (1 == 1)
    {
      a = getch();
      if (a == '\033')
        {
          panic = 1;
          return 0;
        }
      if (a > 47 && a < 58)
        {
          n = a - 48;
          printw ("%c", a);
          return 0;
        }
    }
  return 0;
}

int input_operator()
{ 
  attron (COLOR_PAIR(2));
  pickuno:
  a = mvgetch (15, 35);
  d = 0; 
  if (a == '\033')
    {
      panic = 1;
      return 0;
    }
  if (a == ',')
    {
      d = 1;
      mvprintw (15, 35, "<");
      return 0;
    }
  if (a == '.')
    {
      d = 2;
      mvprintw (15, 35, ">");
      return 0;
    }
  if (a == '=')
    {
      d = 3;
      mvprintw (15, 35, "=");
      return 0;
    }
  goto pickuno;
  return 0;
}
 
int order_numbers()
{
  Cycle:
  curs_set(1);
  clear();
  attron (COLOR_PAIR(7));
  mvprintw (4, 25, "PUT THESE NUMBERS IN ORDER.");
  mvprintw (6, 27, "START WITH THE SMALLEST.");
  attron (COLOR_PAIR(4));
  chance();
  t1 = b; 
  mvprintw (9, 23, "%d", t1);
  chance();
  t2 = b; 
  mvprintw (9, 33, "%d", t2);
  chance();
  t3 = b; 
  mvprintw (9, 43, "%d", t3);
  chance();
  t4 = b; 
  mvprintw (9, 53, "%d", t4);
  refresh();
  attron (COLOR_PAIR(1));
  get_answer();
  if (panic == 1)
    {
      return 0;
    }
  check_order();
  if (win == 1)
    {
      WIN();
      return 0;
    } 
  if (panic == 1)
    {
      return 0;
    }
  goto Cycle;
  return 0;
}

int WIN()
{
  curs_set(0);
  clear();
  for(e = 0; e < 25; e++)
    {
      attron (COLOR_PAIR(color[e]));
      mvprintw (e, e*3, "YOU WIN!  ");
      refresh();
      for (a = 0; a < 8000000; a++) ;
    }
  a=getch();
  if (a == '\033'|a == 13)
    {
      panic = 1;
    }
  score = 0; 
  win = 0;
  return 0;
}

int print_gpl()
{
   clear();
   printw ("\n\n    		    GNU GENERAL PUBLIC LICENSE\n"
"		          Version 2, June 1991\n\n"

" Copyright (C) 1989, 1991 Free Software Foundation, Inc.\n"
" 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA\n"
" Everyone is permitted to copy and distribute verbatim copies\n"
" of this license document, but changing it is not allowed.\n\n"

"			    Preamble\n\n"

"   The licenses for most software are designed to take away your\n"
" freedom to share and change it.  By contrast, the GNU General Public\n"
" License is intended to guarantee your freedom to share and change free\n"
" software--to make sure the software is free for all its users.  This\n"
" General Public License applies to most of the Free Software\n"
" Foundation's software and to any other program whose authors commit to\n"
" using it.  (Some other Free Software Foundation software is covered by\n"
" the GNU Library General Public License instead.)  You can apply it to\n"
" your programs, too.\n\n");
getch();
clear();
printw (
"\n\n   When we speak of free software, we are referring to freedom," 
" not\n"
" price.  Our General Public Licenses are designed to make sure that" 
" you\n"
" have the freedom to distribute copies of free software (and charge" 
" for\n"
" this service if you wish), that you receive source code or can get it\n"
" if you want it, that you can change the software or use pieces of it\n"
" in new free programs; and that you know you can do these things.\n\n"

"   To protect your rights, we need to make restrictions that forbid\n"
" anyone to deny you these rights or to ask you to surrender the" 
" rights.\n"
" These restrictions translate to certain responsibilities for you if" 
" you\n"
" distribute copies of the software, or if you modify it.\n\n"

"   For example, if you distribute copies of such a program, whether\n"
" gratis or for a fee, you must give the recipients all the rights that\n"
" you have.  You must make sure that they, too, receive or can get the\n"
" source code.  And you must show them these terms so they know their\n"
" rights.\n\n"

"   We protect your rights with two steps: (1) copyright the software," 
" and\n"
" (2) offer you this license which gives you legal permission to copy,\n"
" distribute and/or modify the software.");
getch();
clear();
printw (
"\n\n   Also, for each author's protection and ours, we want to make" 
" certain\n"
" that everyone understands that there is no warranty for this free\n"
" software.  If the software is modified by someone else and passed on," 
" we\n"
" want its recipients to know that what they have is not the original," 
" so\n"
" that any problems introduced by others will not reflect on the" 
" original\n"
" authors' reputations.\n\n"

"   Finally, any free program is threatened constantly by software\n"
" patents.  We wish to avoid the danger that redistributors of a free\n"
" program will individually obtain patent licenses, in effect making" 
"the\n"
" program proprietary.  To prevent this, we have made it clear that any\n"
" patent must be licensed for everyone's free use or not licensed at" 
" all.\n\n"

"   The precise terms and conditions for copying, distribution and\n"
" modification follow.\n\n");
getch();
clear();
printw (
"\n\n  		    GNU GENERAL PUBLIC LICENSE\n"
"    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\n\n"

"   0. This License applies to any program or other work which contains\n"
" a notice placed by the copyright holder saying it may be distributed\n"
" under the terms of this General Public License.  The %cProgram%c," 
" below,\n", ch, ch);
printw (
" refers to any such program or work, and a %cwork based on the" 
" Program%c\n"
" means either the Program or any derivative work under copyright law:\n"
" that is to say, a work containing the Program or a portion of it,\n"
" either verbatim or with modifications and/or translated into another\n"
" language.  (Hereinafter, translation is included without limitation" 
" in\n"
" the term %cmodification%c.)  Each licensee is addressed as %cyou%c.\n\n"

" Activities other than copying, distribution and modification are not\n"
" covered by this License; they are outside its scope.  The act of\n"
" running the Program is not restricted, and the output from the" 
" Program\n"
" is covered only if its contents constitute a work based on the\n"
" Program (independent of having been made by running the Program).\n"
" Whether that is true depends on what the Program" 
" does.", ch, ch, ch, ch, ch, ch);
getch();
clear();
printw (
"\n   1. You may copy and distribute verbatim copies of the Program's\n"
" source code as you receive it, in any medium, provided that you\n"
" conspicuously and appropriately publish on each copy an appropriate\n"
" copyright notice and disclaimer of warranty; keep intact all the\n"
" notices that refer to this License and to the absence of any" 
" warranty;\n"
" and give any other recipients of the Program a copy of this License\n"
" along with the Program.\n\n"

" You may charge a fee for the physical act of transferring a copy, and\n"
" you may at your option offer warranty protection in exchange for a" 
" fee.\n\n"

"   2. You may modify your copy or copies of the Program or any portion\n"
" of it, thus forming a work based on the Program, and copy and\n"
" distribute such modifications or work under the terms of Section 1\n"
" above, provided that you also meet all of these conditions:\n\n"

"     a) You must cause the modified files to carry prominent notices\n"
"     stating that you changed the files and the date of any change.\n\n"

"     b) You must cause any work that you distribute or publish, that" 
" in\n"
"     whole or in part contains or is derived from the Program or any\n"
"     part thereof, to be licensed as a whole at no charge to all third\n"
"     parties under the terms of this License.");
getch();
clear();
printw (
"\n\n     c) If the modified program normally reads commands" 
" interactively\n"
"     when run, you must cause it, when started running for such\n"
"     interactive use in the most ordinary way, to print or display an\n"
"     announcement including an appropriate copyright notice and a\n"
"     notice that there is no warranty (or else, saying that you" 
" provide\n"
"     a warranty) and that users may redistribute the program under\n"
"     these conditions, and telling the user how to view a copy of this\n"
"     License.  (Exception: if the Program itself is interactive but\n"
"     does not normally print such an announcement, your work based on\n"
"     the Program is not required to print an announcement.)\n\n"

" These requirements apply to the modified work as a whole.  If\n"
" identifiable sections of that work are not derived from the Program,\n"
" and can be reasonably considered independent and separate works in\n"
" themselves, then this License, and its terms, do not apply to those\n"
" sections when you distribute them as separate works.  But when you\n"
" distribute the same sections as part of a whole which is a work based\n"
" on the Program, the distribution of the whole must be on the terms of\n"
" this License, whose permissions for other licensees extend to the\n"
" entire whole, and thus to each and every part regardless of who wrote" 
" it.");
getch();
clear();
printw (
"\n Thus, it is not the intent of this section to claim rights or" 
" contest\n"
" your rights to work written entirely by you; rather, the intent is to\n"
" exercise the right to control the distribution of derivative or\n"
" collective works based on the Program.\n\n"

" In addition, mere aggregation of another work not based on the" 
" Program\n"
" with the Program (or with a work based on the Program) on a volume of\n"
" a storage or distribution medium does not bring the other work under\n"
" the scope of this License.\n\n"

"   3. You may copy and distribute the Program (or a work based on it,\n"
" under Section 2) in object code or executable form under the terms of\n"
" Sections 1 and 2 above provided that you also do one of the" 
" following:\n\n"

"     a) Accompany it with the complete corresponding machine-readable\n"
"     source code, which must be distributed under the terms of" 
" Sections\n"
"     1 and 2 above on a medium customarily used for software" 
" interchange; or,\n\n"

"     b) Accompany it with a written offer, valid for at least three\n"
"     years, to give any third party, for a charge no more than your\n"
"     cost of physically performing source distribution, a complete\n"
"     machine-readable copy of the corresponding source code, to be\n"
"     distributed under the terms of Sections 1 and 2 above on a medium\n"
"     customarily used for software interchange; or,");
getch();
clear();
printw (
"\n\n     c) Accompany it with the information you received as to the" 
" offer\n"
"     to distribute corresponding source code.  (This alternative is\n"
"     allowed only for noncommercial distribution and only if you\n"
"     received the program in object code or executable form with such\n"
"     an offer, in accord with Subsection b above.)\n\n"

" The source code for a work means the preferred form of the work for\n"
" making modifications to it.  For an executable work, complete source\n"
" code means all the source code for all modules it contains, plus any\n"
" associated interface definition files, plus the scripts used to\n"
" control compilation and installation of the executable.  However, as" 
" a\n"
" special exception, the source code distributed need not include\n"
" anything that is normally distributed (in either source or binary\n"
" form) with the major components (compiler, kernel, and so on) of the\n"
" operating system on which the executable runs, unless that component\n"
" itself accompanies the executable.\n\n"

" If distribution of executable or object code is made by offering\n"
" access to copy from a designated place, then offering equivalent\n"
" access to copy the source code from the same place counts as\n"
" distribution of the source code, even though third parties are not\n"
" compelled to copy the source along with the object code.");
getch();
clear();
printw (
"\n    4. You may not copy, modify, sublicense, or distribute the" 
" Program\n"
"  except as expressly provided under this License.  Any attempt\n"
"  otherwise to copy, modify, sublicense or distribute the Program is\n"
"  void, and will automatically terminate your rights under this" 
" License.\n"
"  However, parties who have received copies, or rights, from you under\n"
" this License will not have their licenses terminated so long as such\n"
" parties remain in full compliance.\n\n"

"   5. You are not required to accept this License, since you have not\n"
" signed it.  However, nothing else grants you permission to modify or\n"
" distribute the Program or its derivative works.  These actions are\n"
" prohibited by law if you do not accept this License.  Therefore, by\n"
" modifying or distributing the Program (or any work based on the\n"
" Program), you indicate your acceptance of this License to do so, and\n"
" all its terms and conditions for copying, distributing or modifying\n"
" the Program or works based on it.\n\n"

"   6. Each time you redistribute the Program (or any work based on the\n"
" Program), the recipient automatically receives a license from the\n"
" original licensor to copy, distribute or modify the Program subject" 
" to\n"
" these terms and conditions.  You may not impose any further\n"
" restrictions on the recipients' exercise of the rights granted" 
" herein.\n"
" You are not responsible for enforcing compliance by third parties to\n"
" this License.");
getch();
clear();
printw (
"\n\n   7. If, as a consequence of a court judgment or allegation of" 
" patent\n"
" infringement or for any other reason (not limited to patent issues),\n"
" conditions are imposed on you (whether by court order, agreement or\n"
" otherwise) that contradict the conditions of this License, they do" 
" not\n"
" excuse you from the conditions of this License.  If you cannot\n"
" distribute so as to satisfy simultaneously your obligations under" 
" this\n"
" License and any other pertinent obligations, then as a consequence" 
" you\n"
" may not distribute the Program at all.  For example, if a patent\n"
" license would not permit royalty-free redistribution of the Program" 
" by\n"
" all those who receive copies directly or indirectly through you, then\n"
" the only way you could satisfy both it and this License would be to\n"
" refrain entirely from distribution of the Program.\n\n"

" If any portion of this section is held invalid or unenforceable under\n"
" any particular circumstance, the balance of the section is intended" 
" to\n"
" apply and the section as a whole is intended to apply in other\n"
" circumstances.");
getch();
clear();
printw (
"\n\n It is not the purpose of this section to induce you to infringe" 
" any\n"
" patents or other property right claims or to contest validity of any\n"
" such claims; this section has the sole purpose of protecting the\n"
" integrity of the free software distribution system, which is\n"
" implemented by public license practices.  Many people have made\n"
" generous contributions to the wide range of software distributed\n"
" through that system in reliance on consistent application of that\n"
" system; it is up to the author/donor to decide if he or she is" 
" willing\n"
" to distribute software through any other system and a licensee cannot\n"
" impose that choice.\n\n"

" This section is intended to make thoroughly clear what is believed to\n"
" be a consequence of the rest of this License.\n\n"

"   8. If the distribution and/or use of the Program is restricted in\n"
" certain countries either by patents or by copyrighted interfaces, the\n"
" original copyright holder who places the Program under this License\n"
" may add an explicit geographical distribution limitation excluding\n"
" those countries, so that distribution is permitted only in or among\n"
" countries not thus excluded.  In such case, this License incorporates\n"
" the limitation as if written in the body of this License.");
getch();
clear();
printw (
"\n\n   9. The Free Software Foundation may publish revised and/or new" 
" versions\n"
" of the General Public License from time to time.  Such new versions" 
" will\n"
" be similar in spirit to the present version, but may differ in detail" 
" to\n"
" address new problems or concerns.\n\n"

" Each version is given a distinguishing version number.  If the" 
" Program\n");
printw (
" specifies a version number of this License which applies to it and" 
" %cany\n", ch);
printw (
" later version%c, you have the option of following the terms and" 
" conditions\n", ch);
printw (
" either of that version or of any later version published by the Free\n"
" Software Foundation.  If the Program does not specify a version number" 
" of\n"
" this License, you may choose any version ever published by the Free" 
" Software\n"
" Foundation.\n\n"

"   10. If you wish to incorporate parts of the Program into other free\n"
" programs whose distribution conditions are different, write to the" 
" author\n"
" to ask for permission.  For software which is copyrighted by the Free\n"
" Software Foundation, write to the Free Software Foundation; we" 
" sometimes\n"
" make exceptions for this.  Our decision will be guided by the two" 
" goals\n"
" of preserving the free status of all derivatives of our free software" 
" and\n"
" of promoting the sharing and reuse of software generally.");
getch();
clear();
printw (
"\n   			    NO WARRANTY\n\n"

"   11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO" 
" WARRANTY\n"
" FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT" 
" WHEN\n"
" OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER" 
" PARTIES\n"
" PROVIDE THE PROGRAM %cAS IS%c WITHOUT WARRANTY OF ANY KIND, EITHER" 
" EXPRESSED\n"
" OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\n"
" MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK" 
" AS\n"
" TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD" 
" THE\n"
" PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY" 
" SERVICING,\n"
" REPAIR OR CORRECTION.\n\n"

"   12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN" 
" WRITING\n"
" WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR\n"
" REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR" 
" DAMAGES,\n"
" INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES" 
" ARISING\n"
" OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT" 
" LIMITED\n"
" TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED" 
" BY\n"
" YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY" 
" OTHER\n"
" PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE\n"
" POSSIBILITY OF SUCH DAMAGES.\n\n"

" 		     END OF TERMS AND CONDITIONS\n", ch, ch);
getch();
clear();
printw (
"\n  	    How to Apply These Terms to Your New Programs\n\n"

"   If you develop a new program, and you want it to be of the greatest\n"
" possible use to the public, the best way to achieve this is to make" 
" it\n"
" free software which everyone can redistribute and change under these" 
" terms.\n\n"

"   To do so, attach the following notices to the program.  It is" 
" safest\n"
" to attach them to the start of each source file to most effectively\n"
" convey the exclusion of warranty; and each file should have at least\n"
" the %ccopyright%c line and a pointer to where the full notice is" 
" found.\n\n"

"     <one line to give the program's name and a brief idea of what it" 
" does.>\n"
"     Copyright (C) <year>  <name of author>\n\n"

"     This program is free software; you can redistribute it and/or" 
" modify\n"
"     it under the terms of the GNU General Public License as published" 
" by\n"
"     the Free Software Foundation; either version 2 of the License, or\n"
"     (at your option) any later version.\n\n"

"     This program is distributed in the hope that it will be useful,\n"
"     but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
"     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
"     GNU General Public License for more details.", ch, ch);
getch();
clear();
printw (
"\n\n     You should have received a copy of the GNU General Public" 
" License\n"
"     along with this program; if not, write to the Free Software\n"
"     Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA"  
" 02110-1301  USA\n\n"


" Also add information on how to contact you by electronic and paper" 
" mail.\n\n"

" If the program is interactive, make it output a short notice like" 
" this\n"
" when it starts in an interactive mode:\n\n"

"     Gnomovision version 69, Copyright (C) year name of author\n"
"     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type" 
" `show w'.\n"
"     This is free software, and you are welcome to redistribute it\n"
"     under certain conditions; type `show c' for details.\n\n"

" The hypothetical commands `show w' and `show c' should show the" 
" appropriate\n"
" parts of the General Public License.  Of course, the commands you use" 
" may\n"
" be called something other than `show w' and `show c'; they could even" 
" be\n"
" mouse-clicks or menu items--whatever suits your program.");
getch();
clear();
printw (
"\n\n\n You should also get your employer (if you work as a programmer)" 
" or" 
" your\n"
" school, if any, to sign a %ccopyright disclaimer%c for the program," 
" if\n"
" necessary.  Here is a sample; alter the names:\n\n"

"   Yoyodyne, Inc., hereby disclaims all copyright interest in the" 
" program\n"
"   `Gnomovision' (which makes passes at compilers) written by James" 
" Hacker.\n\n"

"   <signature of Ty Coon>, 1 April 1989\n"
"   Ty Coon, President of Vice\n\n"

" This General Public License does not permit incorporating your program" 
" into\n"
" proprietary programs.  If your program is a subroutine library, you" 
" may\n"
" consider it more useful to permit linking proprietary applications with" 
" the\n"
" library.  If this is what you want to do, use the GNU Library General\n"
" Public License instead of this License.", ch, ch);
getch();
return 0;
}
