   /*  NUMBER PLEASE CURSES ver 10/17/05  Write numbers in standard form
                   Copyright (C) 2005 by John Slayton
 
This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

Author's address as of 9/17/05 is 260 Sundance Ct, Azusa, CA 91792.
E-mail to www.juanslayton@dialup4less.com  */

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_LIBCCURSES
#include <curses.h>
#else
#include<ncurses/curses.h>
#endif

                          /*  Variables  */ 

long int c = 0; /*  used in WIN() to stop and count  */
int a = 0; /*  holds input from getch(), also loop counter in WIN()  */
int a1 = 0; /*  holds ones digit of student answer  */
int a2 = 0; /*  holds tens digit of student answer  */
int a3 = 0; /*  holds hundreds digit of student answer  */
int a4 = 0; /*  holds thousands digit of student answer  */
int b = 0; /*  a random number generated by rand  */
int d = 0; /*  holds number of digits in current problem  */
int nr = 0; /*  holds current place value being inpu t */
int n1 = 0; /*  holds ones digit of right answer  */
int n2 = 0; /*  holds tens digit of right answer  */
int n3 = 0; /*  holds hundreds digit of right answer  */
int n4 = 0; /*  holds thousands digit of right answer  */
int panic = 0; /*  used to pass through all subroutines on 'escape'  */
int quitflag = 0;
int r = 0 ; /*  a number from hardware clock, used to seed srand  */
int score = 0;
int win = 0;

                   /*  color pairs used by 'win' display  */

int color[25] = {1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5};
      
char ch = '"';
char C[80] = "";
char L[80] = "";

                            /*  spelling list  */
char h[2] = "-";
char N0[5] = "zero";
char N1[4] = "one";
char N2[4] = "two";
char N3[6] = "three";
char N4[5] = "four";
char N5[5] = "five";
char N6[4] = "six";
char N7[6] = "seven";
char N8[6] = "eight";
char N9[5] = "nine";
char N10[4] = "ten";
char N11[7] = "eleven";
char N12[7] = "twelve";
char N13[9] = "thirteen";
char N14[9] = "fourteen";
char N15[8] = "fifteen";
char N16[8] = "sixteen";
char N17[10] = "seventeen";
char N18[9] = "eighteen";
char N19[9] = "nineteen";
char N20[7] = "twenty";
char N30[7] = "thirty";
char N40[6] = "forty";
char N50[6] = "fifty";
char N60[6] = "sixty";
char N70[8] = "seventy";
char N80[7] = "eighty";
char N90[7] = "ninety";
char N100[10] = " hundred ";
char N1000[11] = " thousand ";

char T[80] = "";
char Z[80] = ""; /*  empty string to copy and clear other registers  */

                          /*  Functions  */

int bad(); /*  displays error message and zero score  */
int chance(); /*  returns pseudorandom numbe r  */
int check_answer(); /*  compares student answer with right answer  */
int create(); /*  generates written number  */
int digit1(); /*  selects and spells out ones digit  */
int digit2(); /*  selects and spells out tens digit  */
int digit3(); /*  selects and spells out hundreds digit  */
int digit4(); /*  selects and spells out thousands digit  */
int get_answer(); /* inputs student response  */
int good(); /*  displays score and acknowledges right answer  */
int print_gpl();
int WIN();  /*  acknowledges win score (5 right)  */

int main()
{   

                   /*  SET CURSES PARAMETERS  */

  initscr();
  cbreak();
  noecho();
  nonl();
  intrflush (stdscr, FALSE);
  keypad (stdscr, TRUE);
    
                   /*  SET LETTER ATTRIBUTES  */

  start_color();
  init_pair (1, COLOR_BLACK, COLOR_WHITE);
  init_pair (2, COLOR_RED, COLOR_WHITE);
  init_pair (3, COLOR_GREEN, COLOR_WHITE);
  init_pair (4, COLOR_MAGENTA, COLOR_WHITE);
  init_pair (5, COLOR_BLUE, COLOR_WHITE);
  init_pair (6, COLOR_RED, COLOR_BLACK);
  init_pair (7, COLOR_GREEN, COLOR_BLACK);
  bkgd (COLOR_PAIR(1));

                       /*  TITLE PAGE  */ 

  begin:
  clear();
  attron (A_NORMAL);
  attron (COLOR_PAIR(2));
  mvprintw (3, 18, "               NUMBER PLEASE\n "
  "                               version 10/3/05\n\n\n\n\n");
  attron (COLOR_PAIR(4));
  mvprintw (9, 32, "By John Slayton\n"
    "                                Copyright  2005\n\n\n\n");
  attron (COLOR_PAIR(5));
  mvprintw (14, 28, "Distributable under GNU\n"
  "                            General Public License\n"
  "                        Contact Free Software Foundation\n"
  "                     51 Franklin St, Boston, MA 02110-1301\n\n"
  "  NUMBER PLEASE comes with ABSOLUTELY NO WARRANTY\n"
  "  For license details, type 'D'");
  attron (COLOR_PAIR(2));
  mvprintw (23, 3, "Push Enter to start...");
  refresh();
  a=getch();
  if ((a == 68) || (a == 100))
    {
      print_gpl();
      goto begin;
    }
  if (a != 13)
    {
      goto begin;
    }

                          /*  PRINT MENU  */

  menu:
  curs_set(0);  /*  extinguish cursor  */
  clear();
  win=0;
  attron (COLOR_PAIR(1));
  mvprintw (3, 10, "                     NUMBER PLEASE\n\n"  
  "                         How Big Will the Number Be?\n\n");
  attron (COLOR_PAIR(2));
  printw ("                               A - One Digit\n\n"
         "                               B - Two Digits\n\n"
         "                               C - Three Digits\n\n" 
         "                               D - Four Digits\n\n\n\n\n\n\n");
  refresh();
  create();
  if (panic == 1)
    {
      bkgd (COLOR_PAIR(2));
      score = 0;
    }
  panic=0;
  if (quitflag == 1)
    {
      return 0;
    }
  goto menu; 
}

int bad()
{
  score = 0;
  bkgd (COLOR_PAIR(6));
  attron (COLOR_PAIR(7));
  attron (A_BLINK);
  mvprintw (15, 50, "YOU GOOFED!");
  mvprintw (20, 50, "SCORE IS %d",score);
  attroff (A_BLINK);
  attron (COLOR_PAIR(6));
  mvprintw (23, 3, "Push return to continue...");
  refresh();
  a = 0;
  while (a != 13)
    {
      a = getch();
      if (a == 27)
        {
          panic = 1;
          bkgd (COLOR_PAIR(2));
          return 0;
        }
    }
  bkgd (COLOR_PAIR(2));
  return 0;
}

int chance()  /*  generates random number  */
{
  while (1 == 1)
    {
      b = random() / (20000000); 
      if(b < 10)
        {
          return 0;
        }
    }
}

/*  create() generates problem with anwswer, calls get_answer() for 
student input and check_answer() to check student's answer  */
 
int create() 
{
                /*  Handle Input From Menu Selection  */

  a = 0;
  while (a != 65 && a != 66 && a != 67 && a != 68
         && a != 97 && a != 98 && a != 99 && a != 100)
    { 
      halfdelay(1); /*  makes getch() non blocking  */
      a = getch(); 

            /*  Produce seed number based on elapsed time  */

      r++; /*  will be random number  */
      if (b > 9)
        {
          r = 0;  /*  Increment on each loop, but never more than 9  */
        }

                /*  convert ASCII input to binary 1-5  */

      if (a > 96)
        {
          d = a - 96;  
        }
       else
         {
           d = a - 64; 
         }
    }

  srandom(r);
  Cycle:  
  nocbreak(); /*  getch() will now wait for keypress  */
  cbreak();  /*  getch() will not wait for EOL  */
  strcpy (C, Z); /*  This clears string C  */
  strcpy (L, Z); /*  This clears string L  */
  strcpy (T, Z); /*  This clears string Z  */
  n1 = 0;
  n2 = 0;
  n3 = 0;
  n4 = 0;
  a1 = 0;
  a2 = 0;
  a3 = 0;
  a4 = 0;
  switch (d) /*  Cases correspond to Menu choices  */
    {
      case 1:  digit1(); /*  Select one digit numbers  */ 
               break;   
      case 2:  digit2(); /*  Select two digit numbers  */
               break;
      case 3:  digit2(); /*  Select three digit numbers  */
               digit3();
               break;
      case 4:  again:  /*  Select four digit numbers  */
               digit1(); 
               if (n1 == 48)
                 {
                   goto again; /*  zero is not accepted  */
                 }
               n4 = n1; /*  first digit guaranteed not zero  */
               digit4();
               digit2();
               digit3();
               strcat (T, L);
               strcpy (L, T);
               break;
      default:
                return 0;
    }
  clear();
  attron (COLOR_PAIR(4));
  mvprintw (5, 3, "Can you type in this number?");
  attron (COLOR_PAIR(2));
  mvprintw (10, 3, "%s", L);
  mvprintw (15, 35, " "); 
  refresh();
  get_answer();
  if (panic == 1)
    {
      return 0;
    }
  check_answer();
  if (panic == 1)
    {
      return 0;
    }
  if (win == 1)
    {
      return 0;
    } 
  goto Cycle;
  return 0;
}

int digit1() /*  Create Ones Digit  */
{
  over:
  chance();
  n1 = b + 48; 
  switch (b) /*  Cases correspond to digit place values  */
    { case 0:  if (d == 1)
                 {
                   strcat(L, N0);
                 }
               break;
      case 1:  strcat (L, N1);
               break;
      case 2:  strcat (L, N2);
               break;
      case 3:  strcat (L, N3);
               break;
      case 4:  strcat (L, N4);
               break;
      case 5:  strcat (L, N5);
               break;
      case 6:  strcat (L, N6);
               break;
      case 7:  strcat (L, N7);
               break;
      case 8:  strcat (L, N8);
               break;
      case 9:  strcat (L, N9);
               break;
    }
  return 0;
}

int digit2()  /*  Create tens digit, then call digit1() to create ones  */
{
  rerun:
  chance();
  if (d == 2 && b == 0) /*  No leading zeros on 2 digit numbers  */
    {
      goto rerun;
    }
  n2 = b + 48;
  switch(b)  /*  Cases correspond to digit values  */
    { 
      case 9:  strcat (L, N90); /*  Go spell 'ninety'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N90);
                 }
               break;
      case 8:  strcat (L, N80); /*  Go spell 'eighty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N80);
                 }
               break;
      case 7:  strcat (L, N70); /*  Go spell 'seventy'  */
               strcat (L, h); 
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                    strcpy (L, N70);
                 }
               break;
      case 6:  strcat (L, N60); /*  Go spell 'sixty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N60);
                 }
               break;
      case 5:  strcat (L, N50); /*  Go spell 'fifty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N50);
                 }
               break;
      case 4:  strcat (L, N40); 
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N40);
                 }
               break;
      case 3:  strcat (L, N30);
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N30);
                 }
               break;
      case 2:  strcat (L, N20);  /* go spell 'twenty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N20);
                 }
               break;
      case 0:  digit1(); /*  Go get ones digit */
               break;
      case 1:  chance();
               n1 = b + 48;
               switch (b) /*  Cases correspond to digit place values  */
                { 
                  case 0:  strcat (L, N10);
                           break;
                  case 1:  strcat (L, N11);
                           break;
                  case 2:  strcat (L, N12);
                           break;
                  case 3:  strcat (L, N13);
                           break;
                  case 4:  strcat (L, N14);
                           break;
                  case 5:  strcat (L, N15);
                           break;
                  case 6:  strcat (L, N16);
                           break;
                  case 7:  strcat (L, N17);
                           break;
                  case 8:  strcat (L, N18);
                           break;
                  case 9:  strcat (L, N19);
                }
    }
  return 0;
}

int digit3()
{
  around:
  chance();
  n3 = b + 48;
  if ((d == 3) && (b == 0))
    {
      goto around; /*  No leading zeros allowed  */
    }
  switch (b) /*  Cases correspond to digit place values  */
    {
      case 1:  strcat (C, N1);
               strcat (C, N100); 
               break;
      case 2:  strcat (C, N2);
               strcat (C, N100);
               break;
      case 3:  strcat (C, N3);
               strcat (C, N100);
               break;
      case 4:  strcat (C, N4);
               strcat (C, N100);
               break;
      case 5:  strcat (C, N5);
               strcat (C, N100);
               break;
      case 6:  strcat (C, N6);
               strcat (C, N100);
               break;
      case 7:  strcat (C, N7);
               strcat (C, N100);
               break;
      case 8:  strcat (C, N8);
               strcat (C, N100);
               break;
      case 9:  strcat (C, N9);
               strcat (C, N100);
               break;
      default: return 0;
    }
  strcat (C, L);
  strcpy (L, C);
  return 0;
}

int digit4()
{
  strcat (T, L);
  strcpy (L, Z);
  strcat (T, N1000);
  return 0;
}

int check_answer()
{
  if ((n1 == a1) && (n2 == a2) && (n3 == a3) && (n4 == a4))
    {
      score = score + 1;
      if (score == 5)
        {
          win = 1;
          WIN();
          return 0;
        }
      good();
    } 
  else bad();
  return 0;
}

int get_answer()
{
  curs_set(1);
  attron (COLOR_PAIR(4));
  a1 = 0;
  a2 = 0;
  a3 = 0;
  a4 = 0;
  mvprintw (15, 2, " ");
  for (nr = d; nr > 0; nr--)
    {
      a = 0;
      while (a < 48 || a > 57)
        {
          a = getch();
          if (a == 13)
            {
              break;
            }
          if (a == 27)
            {
              panic = 1;
              return 0;
            }  
        }
      if (a == 13)
        {
          break;
        }
      if (nr == 4)
        {
          a4 = a;
        }
      if (nr == 3)
        {
          a3 = a;
        }
      if (nr == 2)
        {
          a2 = a;
        }
      if (nr == 1)
        {
          a1 = a;
        }
      printw ("%c", a);
      refresh(); 
    }
  while (a != 13)
    {
      a = getch();
    } 
  curs_set(0);
  attron (COLOR_PAIR(2));
  return 0;
} 

int good()
{
  clear();
  attron (COLOR_PAIR(2));
  mvprintw (5, 35, "GOOD WORK!");
  attron (COLOR_PAIR(1));
  mvprintw (10, 35, "SCORE IS %d", score);
  mvprintw (23, 3, "Push return to continue...");
  refresh();
  a = 0;
  while (a != 13)
    {
      a = getch();
      if (a == 27)
        {
          panic = 1;
          return 0;
        }
    }
   attron (COLOR_PAIR(2));
   return 0;
 }

int WIN()
{
  clear();
  for (a = 0; a < 25; a++)
    {
      attron (COLOR_PAIR(color[a]));
      mvprintw (a, a * 3, "YOU WIN!  "); 
      for (c = 0; c < 15000000; c++) ;
      refresh(); 
    }
  attron (COLOR_PAIR(2));
  getch();
  score=0;
  return 0;
}

int print_gpl()
{
   clear();
   printw ("\n\n    		    GNU GENERAL PUBLIC LICENSE\n"
"		          Version 2, June 1991\n\n"

" Copyright (C) 1989, 1991 Free Software Foundation, Inc.\n"
" 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA\n"
" Everyone is permitted to copy and distribute verbatim copies\n"
" of this license document, but changing it is not allowed.\n\n"

"			    Preamble\n\n"

"   The licenses for most software are designed to take away your\n"
" freedom to share and change it.  By contrast, the GNU General Public\n"
" License is intended to guarantee your freedom to share and change free\n"
" software--to make sure the software is free for all its users.  This\n"
" General Public License applies to most of the Free Software\n"
" Foundation's software and to any other program whose authors commit to\n"
" using it.  (Some other Free Software Foundation software is covered by\n"
" the GNU Library General Public License instead.)  You can apply it to\n"
" your programs, too.\n\n");
getch();
clear();
printw (
"\n\n   When we speak of free software, we are referring to freedom," 
" not\n"
" price.  Our General Public Licenses are designed to make sure that" 
" you\n"
" have the freedom to distribute copies of free software (and charge" 
" for\n"
" this service if you wish), that you receive source code or can get it\n"
" if you want it, that you can change the software or use pieces of it\n"
" in new free programs; and that you know you can do these things.\n\n"

"   To protect your rights, we need to make restrictions that forbid\n"
" anyone to deny you these rights or to ask you to surrender the" 
" rights.\n"
" These restrictions translate to certain responsibilities for you if" 
" you\n"
" distribute copies of the software, or if you modify it.\n\n"

"   For example, if you distribute copies of such a program, whether\n"
" gratis or for a fee, you must give the recipients all the rights that\n"
" you have.  You must make sure that they, too, receive or can get the\n"
" source code.  And you must show them these terms so they know their\n"
" rights.\n\n"

"   We protect your rights with two steps: (1) copyright the software," 
" and\n"
" (2) offer you this license which gives you legal permission to copy,\n"
" distribute and/or modify the software.");
getch();
clear();
printw (
"\n\n   Also, for each author's protection and ours, we want to make" 
" certain\n"
" that everyone understands that there is no warranty for this free\n"
" software.  If the software is modified by someone else and passed on," 
" we\n"
" want its recipients to know that what they have is not the original," 
" so\n"
" that any problems introduced by others will not reflect on the" 
" original\n"
" authors' reputations.\n\n"

"   Finally, any free program is threatened constantly by software\n"
" patents.  We wish to avoid the danger that redistributors of a free\n"
" program will individually obtain patent licenses, in effect making" 
"the\n"
" program proprietary.  To prevent this, we have made it clear that any\n"
" patent must be licensed for everyone's free use or not licensed at" 
" all.\n\n"

"   The precise terms and conditions for copying, distribution and\n"
" modification follow.\n\n");
getch();
clear();
printw (
"\n\n  		    GNU GENERAL PUBLIC LICENSE\n"
"    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\n\n"

"   0. This License applies to any program or other work which contains\n"
" a notice placed by the copyright holder saying it may be distributed\n"
" under the terms of this General Public License.  The %cProgram%c," 
" below,\n", ch, ch);
printw (
" refers to any such program or work, and a %cwork based on the" 
" Program%c\n"
" means either the Program or any derivative work under copyright law:\n"
" that is to say, a work containing the Program or a portion of it,\n"
" either verbatim or with modifications and/or translated into another\n"
" language.  (Hereinafter, translation is included without limitation" 
" in\n"
" the term %cmodification%c.)  Each licensee is addressed as %cyou%c.\n\n"

" Activities other than copying, distribution and modification are not\n"
" covered by this License; they are outside its scope.  The act of\n"
" running the Program is not restricted, and the output from the" 
" Program\n"
" is covered only if its contents constitute a work based on the\n"
" Program (independent of having been made by running the Program).\n"
" Whether that is true depends on what the Program" 
" does.", ch, ch, ch, ch, ch, ch);
getch();
clear();
printw (
"\n   1. You may copy and distribute verbatim copies of the Program's\n"
" source code as you receive it, in any medium, provided that you\n"
" conspicuously and appropriately publish on each copy an appropriate\n"
" copyright notice and disclaimer of warranty; keep intact all the\n"
" notices that refer to this License and to the absence of any" 
" warranty;\n"
" and give any other recipients of the Program a copy of this License\n"
" along with the Program.\n\n"

" You may charge a fee for the physical act of transferring a copy, and\n"
" you may at your option offer warranty protection in exchange for a" 
" fee.\n\n"

"   2. You may modify your copy or copies of the Program or any portion\n"
" of it, thus forming a work based on the Program, and copy and\n"
" distribute such modifications or work under the terms of Section 1\n"
" above, provided that you also meet all of these conditions:\n\n"

"     a) You must cause the modified files to carry prominent notices\n"
"     stating that you changed the files and the date of any change.\n\n"

"     b) You must cause any work that you distribute or publish, that" 
" in\n"
"     whole or in part contains or is derived from the Program or any\n"
"     part thereof, to be licensed as a whole at no charge to all third\n"
"     parties under the terms of this License.");
getch();
clear();
printw (
"\n\n     c) If the modified program normally reads commands" 
" interactively\n"
"     when run, you must cause it, when started running for such\n"
"     interactive use in the most ordinary way, to print or display an\n"
"     announcement including an appropriate copyright notice and a\n"
"     notice that there is no warranty (or else, saying that you" 
" provide\n"
"     a warranty) and that users may redistribute the program under\n"
"     these conditions, and telling the user how to view a copy of this\n"
"     License.  (Exception: if the Program itself is interactive but\n"
"     does not normally print such an announcement, your work based on\n"
"     the Program is not required to print an announcement.)\n\n"

" These requirements apply to the modified work as a whole.  If\n"
" identifiable sections of that work are not derived from the Program,\n"
" and can be reasonably considered independent and separate works in\n"
" themselves, then this License, and its terms, do not apply to those\n"
" sections when you distribute them as separate works.  But when you\n"
" distribute the same sections as part of a whole which is a work based\n"
" on the Program, the distribution of the whole must be on the terms of\n"
" this License, whose permissions for other licensees extend to the\n"
" entire whole, and thus to each and every part regardless of who wrote" 
" it.");
getch();
clear();
printw (
"\n Thus, it is not the intent of this section to claim rights or" 
" contest\n"
" your rights to work written entirely by you; rather, the intent is to\n"
" exercise the right to control the distribution of derivative or\n"
" collective works based on the Program.\n\n"

" In addition, mere aggregation of another work not based on the" 
" Program\n"
" with the Program (or with a work based on the Program) on a volume of\n"
" a storage or distribution medium does not bring the other work under\n"
" the scope of this License.\n\n"

"   3. You may copy and distribute the Program (or a work based on it,\n"
" under Section 2) in object code or executable form under the terms of\n"
" Sections 1 and 2 above provided that you also do one of the" 
" following:\n\n"

"     a) Accompany it with the complete corresponding machine-readable\n"
"     source code, which must be distributed under the terms of" 
" Sections\n"
"     1 and 2 above on a medium customarily used for software" 
" interchange; or,\n\n"

"     b) Accompany it with a written offer, valid for at least three\n"
"     years, to give any third party, for a charge no more than your\n"
"     cost of physically performing source distribution, a complete\n"
"     machine-readable copy of the corresponding source code, to be\n"
"     distributed under the terms of Sections 1 and 2 above on a medium\n"
"     customarily used for software interchange; or,");
getch();
clear();
printw (
"\n\n     c) Accompany it with the information you received as to the" 
" offer\n"
"     to distribute corresponding source code.  (This alternative is\n"
"     allowed only for noncommercial distribution and only if you\n"
"     received the program in object code or executable form with such\n"
"     an offer, in accord with Subsection b above.)\n\n"

" The source code for a work means the preferred form of the work for\n"
" making modifications to it.  For an executable work, complete source\n"
" code means all the source code for all modules it contains, plus any\n"
" associated interface definition files, plus the scripts used to\n"
" control compilation and installation of the executable.  However, as" 
" a\n"
" special exception, the source code distributed need not include\n"
" anything that is normally distributed (in either source or binary\n"
" form) with the major components (compiler, kernel, and so on) of the\n"
" operating system on which the executable runs, unless that component\n"
" itself accompanies the executable.\n\n"

" If distribution of executable or object code is made by offering\n"
" access to copy from a designated place, then offering equivalent\n"
" access to copy the source code from the same place counts as\n"
" distribution of the source code, even though third parties are not\n"
" compelled to copy the source along with the object code.");
getch();
clear();
printw (
"\n    4. You may not copy, modify, sublicense, or distribute the" 
" Program\n"
"  except as expressly provided under this License.  Any attempt\n"
"  otherwise to copy, modify, sublicense or distribute the Program is\n"
"  void, and will automatically terminate your rights under this" 
" License.\n"
"  However, parties who have received copies, or rights, from you under\n"
" this License will not have their licenses terminated so long as such\n"
" parties remain in full compliance.\n\n"

"   5. You are not required to accept this License, since you have not\n"
" signed it.  However, nothing else grants you permission to modify or\n"
" distribute the Program or its derivative works.  These actions are\n"
" prohibited by law if you do not accept this License.  Therefore, by\n"
" modifying or distributing the Program (or any work based on the\n"
" Program), you indicate your acceptance of this License to do so, and\n"
" all its terms and conditions for copying, distributing or modifying\n"
" the Program or works based on it.\n\n"

"   6. Each time you redistribute the Program (or any work based on the\n"
" Program), the recipient automatically receives a license from the\n"
" original licensor to copy, distribute or modify the Program subject" 
" to\n"
" these terms and conditions.  You may not impose any further\n"
" restrictions on the recipients' exercise of the rights granted" 
" herein.\n"
" You are not responsible for enforcing compliance by third parties to\n"
" this License.");
getch();
clear();
printw (
"\n\n   7. If, as a consequence of a court judgment or allegation of" 
" patent\n"
" infringement or for any other reason (not limited to patent issues),\n"
" conditions are imposed on you (whether by court order, agreement or\n"
" otherwise) that contradict the conditions of this License, they do" 
" not\n"
" excuse you from the conditions of this License.  If you cannot\n"
" distribute so as to satisfy simultaneously your obligations under" 
" this\n"
" License and any other pertinent obligations, then as a consequence" 
" you\n"
" may not distribute the Program at all.  For example, if a patent\n"
" license would not permit royalty-free redistribution of the Program" 
" by\n"
" all those who receive copies directly or indirectly through you, then\n"
" the only way you could satisfy both it and this License would be to\n"
" refrain entirely from distribution of the Program.\n\n"

" If any portion of this section is held invalid or unenforceable under\n"
" any particular circumstance, the balance of the section is intended" 
" to\n"
" apply and the section as a whole is intended to apply in other\n"
" circumstances.");
getch();
clear();
printw (
"\n\n It is not the purpose of this section to induce you to infringe" 
" any\n"
" patents or other property right claims or to contest validity of any\n"
" such claims; this section has the sole purpose of protecting the\n"
" integrity of the free software distribution system, which is\n"
" implemented by public license practices.  Many people have made\n"
" generous contributions to the wide range of software distributed\n"
" through that system in reliance on consistent application of that\n"
" system; it is up to the author/donor to decide if he or she is" 
" willing\n"
" to distribute software through any other system and a licensee cannot\n"
" impose that choice.\n\n"

" This section is intended to make thoroughly clear what is believed to\n"
" be a consequence of the rest of this License.\n\n"

"   8. If the distribution and/or use of the Program is restricted in\n"
" certain countries either by patents or by copyrighted interfaces, the\n"
" original copyright holder who places the Program under this License\n"
" may add an explicit geographical distribution limitation excluding\n"
" those countries, so that distribution is permitted only in or among\n"
" countries not thus excluded.  In such case, this License incorporates\n"
" the limitation as if written in the body of this License.");
getch();
clear();
printw (
"\n\n   9. The Free Software Foundation may publish revised and/or new" 
" versions\n"
" of the General Public License from time to time.  Such new versions" 
" will\n"
" be similar in spirit to the present version, but may differ in detail" 
" to\n"
" address new problems or concerns.\n\n"

" Each version is given a distinguishing version number.  If the" 
" Program\n");
printw (
" specifies a version number of this License which applies to it and" 
" %cany\n", ch);
printw (
" later version%c, you have the option of following the terms and" 
" conditions\n", ch);
printw (
" either of that version or of any later version published by the Free\n"
" Software Foundation.  If the Program does not specify a version number" 
" of\n"
" this License, you may choose any version ever published by the Free" 
" Software\n"
" Foundation.\n\n"

"   10. If you wish to incorporate parts of the Program into other free\n"
" programs whose distribution conditions are different, write to the" 
" author\n"
" to ask for permission.  For software which is copyrighted by the Free\n"
" Software Foundation, write to the Free Software Foundation; we" 
" sometimes\n"
" make exceptions for this.  Our decision will be guided by the two" 
" goals\n"
" of preserving the free status of all derivatives of our free software" 
" and\n"
" of promoting the sharing and reuse of software generally.");
getch();
clear();
printw (
"\n   			    NO WARRANTY\n\n"

"   11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO" 
" WARRANTY\n"
" FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT" 
" WHEN\n"
" OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER" 
" PARTIES\n"
" PROVIDE THE PROGRAM %cAS IS%c WITHOUT WARRANTY OF ANY KIND, EITHER" 
" EXPRESSED\n"
" OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\n"
" MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK" 
" AS\n"
" TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD" 
" THE\n"
" PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY" 
" SERVICING,\n"
" REPAIR OR CORRECTION.\n\n"

"   12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN" 
" WRITING\n"
" WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR\n"
" REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR" 
" DAMAGES,\n"
" INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES" 
" ARISING\n"
" OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT" 
" LIMITED\n"
" TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED" 
" BY\n"
" YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY" 
" OTHER\n"
" PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE\n"
" POSSIBILITY OF SUCH DAMAGES.\n\n"

" 		     END OF TERMS AND CONDITIONS\n", ch, ch);
getch();
clear();
printw (
"\n  	    How to Apply These Terms to Your New Programs\n\n"

"   If you develop a new program, and you want it to be of the greatest\n"
" possible use to the public, the best way to achieve this is to make" 
" it\n"
" free software which everyone can redistribute and change under these" 
" terms.\n\n"

"   To do so, attach the following notices to the program.  It is" 
" safest\n"
" to attach them to the start of each source file to most effectively\n"
" convey the exclusion of warranty; and each file should have at least\n"
" the %ccopyright%c line and a pointer to where the full notice is" 
" found.\n\n"

"     <one line to give the program's name and a brief idea of what it" 
" does.>\n"
"     Copyright (C) <year>  <name of author>\n\n"

"     This program is free software; you can redistribute it and/or" 
" modify\n"
"     it under the terms of the GNU General Public License as published" 
" by\n"
"     the Free Software Foundation; either version 2 of the License, or\n"
"     (at your option) any later version.\n\n"

"     This program is distributed in the hope that it will be useful,\n"
"     but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
"     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
"     GNU General Public License for more details.", ch, ch);
getch();
clear();
printw (
"\n\n     You should have received a copy of the GNU General Public" 
" License\n"
"     along with this program; if not, write to the Free Software\n"
"     Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA"  
" 02110-1301  USA\n\n"


" Also add information on how to contact you by electronic and paper" 
" mail.\n\n"

" If the program is interactive, make it output a short notice like" 
" this\n"
" when it starts in an interactive mode:\n\n"

"     Gnomovision version 69, Copyright (C) year name of author\n"
"     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type" 
" `show w'.\n"
"     This is free software, and you are welcome to redistribute it\n"
"     under certain conditions; type `show c' for details.\n\n"

" The hypothetical commands `show w' and `show c' should show the" 
" appropriate\n"
" parts of the General Public License.  Of course, the commands you use" 
" may\n"
" be called something other than `show w' and `show c'; they could even" 
" be\n"
" mouse-clicks or menu items--whatever suits your program.");
getch();
clear();
printw (
"\n\n\n You should also get your employer (if you work as a programmer)" 
" or" 
" your\n"
" school, if any, to sign a %ccopyright disclaimer%c for the program," 
" if\n"
" necessary.  Here is a sample; alter the names:\n\n"

"   Yoyodyne, Inc., hereby disclaims all copyright interest in the" 
" program\n"
"   `Gnomovision' (which makes passes at compilers) written by James" 
" Hacker.\n\n"

"   <signature of Ty Coon>, 1 April 1989\n"
"   Ty Coon, President of Vice\n\n"

" This General Public License does not permit incorporating your program" 
" into\n"
" proprietary programs.  If your program is a subroutine library, you" 
" may\n"
" consider it more useful to permit linking proprietary applications with" 
" the\n"
" library.  If this is what you want to do, use the GNU Library General\n"
" Public License instead of this License.", ch, ch);
getch();
return 0;
}
